/* --------------------------------
** FILE
**      illu-proc.h
**
** DESCRIPTION
**      include file for illu-proc.c
**
** $Header: /users/vis/jta/www/illu-proc/RCS/illu-proc.h,v 1.3 1994/10/03 16:12:48 jta Exp $
*/

#include <stdio.h>
#include <string.h> 
#include <stdlib.h> 
#include <ctype.h> 
#include <mi.h>

#define FIELD_SEP_SIZE    3
#define DEFAULT_COL_SIZE 15
#define PAD_SIZE         100
#define WRAP_LINES       25 

typedef struct column_info
{
     char *col_data, 
          *col_name;
     int  col_width,    /* max width from proc file */
          col_offset,   /* from column 0            */
          last_offset,  /* where did we leave off?  */
          col_data_len; /* actual data length       */
} COLUMN_INFO;

FILE *fp, *fopen();

MI_CONNECTION * init_illustra();    
void  all_callback(MI_EVENT_TYPE type, MI_CONNECTION *conn, void *s1, void *s2);
int   alloc_ww_buff(char ***buff, size_t *ww_num);
void  cleanup(MI_CONNECTION *conn, char *query);
void  cleanup_results(char **tmp_char, COLUMN_INFO *column_data, int ncols);
void  decode_cgi_hex(char *str, char *result);
int   execute_sql (char *sqlstring);  
void  free_header_info(COLUMN_INFO *column_data, int ncols);
int   get_header_info(MI_ROW *row, int *ncols, COLUMN_INFO **column_data, char *ww_col, int *ww);
int   get_column_vals(MI_ROW *row, int ncols, COLUMN_INFO *column_data);
int   get_column_vals2(MI_ROW *row, int ncols, COLUMN_INFO *column_data);
void  print_header(COLUMN_INFO *column_data, int ncols);
int   print_results(MI_CONNECTION *conn);
int   process_results(MI_CONNECTION *conn);  
char *query_rewrite(char *str);
int   set_ww_ptr(char *in, int col_width, char ***out, size_t *ww_nm);

extern char * app_getdefine(char *ss);
